---
sidebar_position: 2
description: 开源之夏 - 暑期 2023
---

# 暑期 2023

**开源之夏 - 暑期 2023** 是由**开源软件供应链点亮计划**发起、由**中国科学院软件研究所**与 **openEuler 社区**主办的一项面向高校学生的暑期活动，类似 Google Summer of Code（GSoC），旨在鼓励在校学生积极参与开源软件的开发维护，促进优秀开源软件社区的蓬勃发展。关于具体的活动规划、报名方式，请查看该活动的 [官网](https://summer-ospp.ac.cn/) 和 [帮助文档](https://summer-ospp.ac.cn/help/)。

NoneBot 社区有幸作为开源社区 [参与](https://summer-ospp.ac.cn/org/orgdetail/e1fb5b8d-125a-4138-b756-25bd32c0a31a?lang=zh) 了本次活动，下面列出了目前我们已经发布的项目，欢迎感兴趣的同学通过 <contact@nonebot.dev> 联系我们。

## NoneBot 项目管理图形化面板

NoneBot 目前提供了开箱即用的命令行脚手架来帮助初次使用的用户更快的上手编写应用。但是，对于未有一定开发经验的用户，命令行的使用仍具有一定的困难。此外，其他项目如 koishi、vue 等，均可通过图形化界面的形式为用户提供更便捷的项目开发。因此，我们希望借助现有命令行脚手架的可扩展特性，提供一个项目管理面板服务，以网页的形式帮助用户开发 NoneBot 应用。

**难度**：进阶

**导师**：[@mnixry](https://github.com/mnixry)

**产出要求**

- 设计并实现项目管理面板相关功能
  - 创建与管理项目
  - 配置与运行项目
  - NoneBot 插件管理
- 实现相应 nb-cli 插件提供面板服务
- 代码符合 NoneBot Contributing 规范

**技术要求**

- 熟悉 nb-cli 相关功能
- 熟悉 NoneBot 框架功能
- 熟悉前后端相关实现方式

**成果仓库**

- <https://github.com/nonebot/cli-plugin-webui>

## NoneBot Discord 适配器

NoneBot 作为一个跨平台聊天机器人框架，目前已有 OneBot、飞书、Telegram、QQ 频道等诸多平台的适配支持。作为众多用户期待的平台适配之一，我们希望借此机会接入 Discord 聊天机器人。

**难度**：进阶

**导师**：[@iyume](https://github.com/iyume)

**产出要求**

- 调研 Discord Bot 相关功能与接口
- 设计与编写 NoneBot Discord 适配器
- 代码符合 NoneBot Contributing 规范

**技术要求**

- 熟悉 NoneBot 框架功能
- 熟悉 NoneBot 各模块职责与适配器编写

**成果仓库**

- <https://github.com/nonebot/adapter-discord>

## NoneBot 数据库支持插件

NoneBot 的插件系统为用户实现应用提供了极高的便捷性，但因此也增加了插件统一管理的难度。目前，我们发现许多用户发布的插件中存在文件存储结构化数据、数据存放散乱等现象，同时插件间也可能产生冲突。因此，我们希望提供一个统一的数据存储与管理方式，便于用户读写应用数据。

**难度**：进阶

**导师**：[@yanyongyu](https://github.com/yanyongyu)

**产出要求**

- 设计并实现 ORM 插件
  - 提供关系模型定义功能
  - 提供模型迁移与管理功能
  - 能较好的支持 Python 类型检查与推导
- 编写相应的用户使用文档
- 代码符合 NoneBot Contributing 规范

**技术要求**

- 熟悉 NoneBot 框架功能与插件编写
- 熟悉 SQLAlchemy 等 ORM 框架
  - 熟悉 SQLAlchemy ORM
  - 熟悉 alembic 等迁移工具
- 熟悉 nb-cli 插件编写

**成果仓库**

- <https://github.com/nonebot/plugin-orm>
